; *******************
;   
; *******************

Global ComProg_Delay.l       ; ,   
Global ComProg_DataOut_Inv.c ;     DTR (1-, 0-)
Global ComProg_DataIn_Inv.c  ;     CTS (1-, 0-)
Global ComProg_Clock_Inv.c   ;    RTS (1-, 0-)
Global ComProg_Pitanie.c     ;    (1-, 0-)
Global ComPortName.s         ;  ,    

Global ComProg_ComId.l=0 ;   COM .

Procedure ComProg_Init()
  ;     Preferences.ini
  If OpenPreferences("Preferences.ini")=0
    MessageRequester("", " Preferences.ini  ", 16)
  EndIf
  ;  
  ComProg_Delay       = ReadPreferenceLong("ComProg_Delay",200)
  ComProg_DataOut_Inv = ReadPreferenceLong("ComProg_DataOut_Inv",0)
  ComProg_DataIn_Inv  = ReadPreferenceLong("ComProg_DataIn_Inv",0)
  ComProg_Clock_Inv   = ReadPreferenceLong("ComProg_Clock_Inv",0)
  ComProg_Pitanie     = ReadPreferenceLong("ComProg_Pitanie",0)
  ComPortName         = ReadPreferenceString("ComPortName","COM1")
  ClosePreferences()
EndProcedure

Procedure ComProg_Test()
  ;     (  DSR  RTS)
  
  Delay(10) ;   10 .
  ComSetRTS(ComProg_ComId,1) ;  . 1   RTS
  Delay(10) ;   10 .
  If ComGetDSR(ComProg_ComId)<>1
    ProcedureReturn 0 ; ,   !
  EndIf
  ComSetRTS(ComProg_ComId,0) ;  . 0   RTS
  Delay(10) ;   10 .
  If ComGetDSR(ComProg_ComId)<>0
    ProcedureReturn 0 ; ,   !
  EndIf
  Delay(10) ;   10 .
  
  ProcedureReturn 1 ;  .
EndProcedure

Procedure.c ComProg_DataIn()
  ;     
  
  If ComProg_Clock_Inv=1 ;   
    Start.c=0 : Stop.c=1
  Else ;    
    Start.c=1 : Stop.c=0
  EndIf
  
  ComSetRTS(ComProg_ComId,Start)  ;   (   )
  MicroDelayTimer(ComProg_Delay)  ; 
  ComSetRTS(ComProg_ComId,Stop)   ;   (   )
  MicroDelayTimer(ComProg_Delay)  ; 
  MicroDelayTimer(ComProg_Delay)  ; 
  Bit.c=ComGetCTS(ComProg_ComId)  ;  
  
  If ComProg_DataIn_Inv=1 ;    
    Bit=Bit!1 ;  
  EndIf
  ProcedureReturn Bit
EndProcedure

Procedure ComProg_DataOut(Bit.c)
  ;    
  
  If Bit>0
    Bit_x.c=1 ;   Bit  
  Else
    Bit_x.c=0 ;   Bit    
  EndIf
  If ComProg_DataOut_Inv=1 ;    
    Bit_x=Bit_x!1 ;  
  EndIf
  If ComProg_Clock_Inv=1 ;   
    Start.c=0 : Stop.c=1
  Else ;    
    Start.c=1 : Stop.c=0
  EndIf
  ComSetDTR(ComProg_ComId,Bit_x)  ;  
  MicroDelayTimer(ComProg_Delay)  ; 
  MicroDelayTimer(ComProg_Delay)  ; 
  ComSetRTS(ComProg_ComId,Start)  ;   (   )
  MicroDelayTimer(ComProg_Delay)  ; 
  ComSetRTS(ComProg_ComId,Stop)   ;   (   )
  MicroDelayTimer(ComProg_Delay)  ; 
EndProcedure

Procedure ComProg_StartStop(State.c)
  ;  (State=1)   (State=0)  .
  
  ;  .    CLOCK
  If ComProg_Clock_Inv = 1 ;  
    ComSetRTS(ComProg_ComId,1)   
  Else
    ComSetRTS(ComProg_ComId,0)
  EndIf
  ;  .    DATA
  If ComProg_DataOut_Inv = 1 ;  
    ComSetDTR(ComProg_ComId,1)
  Else
    ComSetDTR(ComProg_ComId,0)
  EndIf 
  
  Delay(40)
  
  If State>0
    StatePit=1
  Else
    StatePit=0
  EndIf
  If ComProg_Pitanie=1 ;  
    StatePit=StatePit!1
  EndIf
  ComSetTXD(ComProg_ComId, StatePit)
EndProcedure

Procedure ComProg_OutByteCommand(DataOut.c)
  ;    
  For i=1 To 6 ;    (6 )
    Out.c=DataOut
    Out=Out & 1 ;     
    ComProg_DataOut(Out) ;   
    DataOut=DataOut>>1 ;      .
  Next i
EndProcedure

Procedure ComProg_OutByteData(DataOut.l)
  ;    
  DataOut=DataOut<<1 ;      
  DataOut=DataOut & %0111111111111110 ;     
  For i=1 To 16 ;    (16 )
    Out.l=DataOut
    Out=Out & 1 ;     
    ComProg_DataOut(Out) ;   
    DataOut=DataOut>>1 ;      .
  Next i
EndProcedure

Procedure.l ComProg_InByteData()
  ;     
  
  ;       
  If ComProg_DataOut_Inv=1 ;    
    ComSetDTR(ComProg_ComId,0)
  Else
    ComSetDTR(ComProg_ComId,1)
  EndIf
  
  For i=1 To 16 ;    (16 )
    Bit.c=ComProg_DataIn() ;    
    If Bit=0 ;    
      In=In & %0111111111111111 ;  15    " "
    Else ;    
      In=In | %1000000000000000 ;  15    " "
    EndIf
    In=In>>1 ;      .
  Next i
  
  In=In & $3FFF ;  14  15 
  ProcedureReturn In
EndProcedure

Procedure OpenCom_Port(Port.s)
  ;  COM 
  ResultPotr.s=Port+":9600,N,8,1"
  ComProg_ComId=ComOpen(ResultPotr,#HandShakeModeNone,1,1)
  ProcedureReturn ComProg_ComId
EndProcedure

Procedure CloseCom_Port()
  ;  COM 
  ComClose(ComProg_ComId)
  ComProg_ComId=0
EndProcedure

; IDE Options = PureBasic 4.51 (Windows - x86)
; CursorPosition = 152
; FirstLine = 140
; Folding = --