; FFT    
; @SAM  Rubtsovsk 2007

Structure complex
  real.f
  imag.f
EndStructure  

Global Dim Pow2.l(0), Dim SinA.f(0), Dim CosA.f(0),Dim Win.f(0)
Global fftn.l, ffts.l

Procedure InitFFT(fftnum.l)
fftn=fftnum
ffts=Pow(2,fftn)
ReDim Pow2.l(fftn)
ReDim Win.f(ffts)
ReDim SinA.f(ffts>>1)
ReDim CosA.f(ffts>>1)
For i=0 To fftn
  Pow2(i)=Pow(2,i)
Next
For i=0 To ffts>>1
  SinA(i)=Sin( #PI / (i+1))
  CosA(i)=Cos( #PI / (i+1))
Next
For i=0 To ffts
   ;W[i] := 0.54 - 0.46*Cos(2*pi*i/nn);//
   Win(i) = 0.5 - 0.5*Cos(2*#PI*i/ffts);//
   ;W[i] := 0.42 - 0.5*Cos(2*pi*i/nn) + 0.08*Cos(4*pi*i/nn);//
   ;W[i] := 0.35875 - 0.48829*Cos(2*pi*i/nn) + 0.14128*Cos(4*pi*i/nn)
   ;;- 0.01168*Cos(6*pi*i/nn);//-
   ;Win(i) = 0.01168*Cos(6*#PI*i/nn);//-
   ;fftW(i)0.42 - 0.5*os(2*pi*n/N-1) + 0.08*Cos(4*pi*n/N-1)
Next   
EndProcedure

Procedure GetFFT(Array a.complex(1), inversefft.l)
  Protected sign,le,le1,k,ip,i,j
  Protected ur.f,ui.f,wr.f,wi.f,tr.f,ti.f,temp.f
    j = 1
    For i = 1 To  ffts-1
        If i < j
            Swap a(j)\real,a(i)\real
            Swap a(j)\imag,a(i)\imag
        EndIf
        k = ffts >> 1
        While k < j 
         j =  j - k 
         k = k >> 1
        Wend        
        j = j + k
    Next
    If inversefft
        sign = 1
    Else
        sign = -1
    EndIf     
    For l = 1 To  fftn   
        le = Pow2(l)
        le1 = le >> 1
        ur = 1.0
        ui = 0
        wr = CosA(le1)
        wi = sign * SinA(le1)
        For j = 1 To le1      
            i = j
            While i <= ffts           
                ip = i + le1
                tr = a(ip)\real*ur - a(ip)\imag*ui
                ti = a(ip)\imag*ur + a(ip)\real*ui
                a(ip)\real = a(i)\real - tr
                a(ip)\imag = a(i)\imag - ti
                a(i)\real = a(i)\real + tr
                a(i)\imag = a(i)\imag + ti
                i = i + le
            Wend
            temp = ur*wr - ui*wi
            ui = ui*wr + ur*wi
            ur = temp       
        Next
    Next 
    If Not inversefft   
        For i = 1 To ffts       
            a(i)\real = a(i)\real / ffts
            a(i)\imag = a(i)\imag / ffts
        Next
    EndIf
EndProcedure


; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 31
; FirstLine = 9
; Folding = -