; Function set for Input and Output Sound use WinAPI 
; Ver 1.0a 
; @SAM 2007 Rubtsovsk 

;-Struct 
CompilerIf Defined(WAVEFORMATEX, #PB_Structure)=0
  Structure WAVEFORMATEX 
    wFormatTag.w 
    nChannels.w 
    nSamplesPerSec.l 
    nAvgBytesPerSec.l 
    nBlockAlign.w 
    wBitsPerSample.w 
    cbSize.w 
  EndStructure 
CompilerEndIf

;-Const 
;     
#iosNO_ERR=0; ,   
#iosERR=1;,-  
#iosBAD_PAR=2;       
#iosABSENT=3; , ..    
#iosPROCESS=4;, ..   
#iosNO_INIT=5;, ..    

;-Var 
Global iosProcessStart.l;    
Global ioswo.l,ioswi.l; ,    -. 
Global ios.WAVEFORMATEX;    
Global Dim iosbufIN.WAVEHDR(8),Dim iosbufOUT.WAVEHDR(8);  8-  (In/Out) 
Global iosNBuf.l,iosBufSize.l; -      2 
Global Dim OutBuf.l(8), Dim InBuf.l(8);   
Global *iosFunc;      

;-function 

;      ,      
Procedure iosInOutProc( hwi.l, uMsg.l, dwInstance.l, dwParam1.l, dwParam2.l) 
 If   iosProcessStart=1 
  If uMsg=#MM_WIM_DATA 
    For i=0 To iosNBuf 
      If (iosbufIN(i)\dwFlags & #WHDR_DONE) = #WHDR_DONE                    
       waveInAddBuffer_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));    
       CallFunctionFast( *iosFunc,InBuf(i),OutBuf(i),iosBufSize);   
       waveOutWrite_(ioswo,@iosbufOUT(i), SizeOf(WAVEHDR));        
      EndIf    
    Next    
  EndIf 
 Else 
  iosProcessStart=-1 
 EndIf 
EndProcedure 

;            
Procedure iosOutProc( hwi.l, uMsg.l, dwInstance.l, dwParam1.l, dwParam2.l) 
 If   iosProcessStart=1 
  If uMsg=#MM_WIM_DATA 
    For i=0 To iosNBuf 
      If (iosbufIN(i)\dwFlags & #WHDR_DONE) = #WHDR_DONE                  
       waveInAddBuffer_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));    
       CallFunctionFast( *iosFunc,OutBuf(i),iosBufSize);   
       waveOutWrite_(ioswo,@iosbufOUT(i), SizeOf(WAVEHDR));        
      EndIf    
    Next    
  EndIf 
 Else 
  iosProcessStart=-1 
 EndIf 
EndProcedure 

;            
Procedure iosInProc( hwi.l, uMsg.l, dwInstance.l, dwParam1.l, dwParam2.l) 
 If   iosProcessStart=1 
  If uMsg=#MM_WIM_DATA 
    For i=0 To iosNBuf 
      If (iosbufIN(i)\dwFlags & #WHDR_DONE) = #WHDR_DONE                    
        waveInAddBuffer_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));    
        CallFunctionFast( *iosFunc,InBuf(i),iosBufSize);   
      EndIf    
    Next    
  EndIf 
 Else 
  iosProcessStart=-1  
 EndIf 
EndProcedure 

;  
;NBuf - (2-8) 
;BufSize    2 (8-16).. 256-65536  
;SamplesPerSec   (     8000  96000) 
;BitsPerSample    (8,16,24,32) 
;Channels -  (1  2) 
; #iosPROCESS-  ,#iosBAD_PAR-  ,#iosNO_ERR-   
;  ,       
Procedure.l iosSetFormSound(NBuf.l,BufSize.l,SamplesPerSec.l,BitsPerSample.l,Channels.l) 
  Protected i.l 
  If iosProcessStart=1 
    ProcedureReturn #iosPROCESS 
  EndIf 
  If BufSize<8 And BufSize>16 
    ProcedureReturn #iosBAD_PAR 
  EndIf  
  If NBuf<2 And NBuf>8 
    ProcedureReturn #iosBAD_PAR 
  EndIf 
  If BitsPerSample<>8 And BitsPerSample<>16 And BitsPerSample<>24 And BitsPerSample<>32 
    ProcedureReturn #iosBAD_PAR 
  EndIf 
  If Channels<>2 And Channels<>1 
    ProcedureReturn #iosBAD_PAR 
  EndIf 
  If  SamplesPerSec<>24000 And SamplesPerSec<>32000 And SamplesPerSec<>44100 And SamplesPerSec<>48000 And SamplesPerSec<>96000 And SamplesPerSec<>16000 And SamplesPerSec<>22050 And SamplesPerSec<>11025 And SamplesPerSec<>8000 
    ProcedureReturn #iosBAD_PAR 
  EndIf                  
  iosNBuf=NBuf-1 
  iosBufSize=(Channels*Pow(2,BufSize))*(BitsPerSample/8) 
  For i=0 To iosNBuf 
    If  OutBuf(i)
      FreeMemory(OutBuf(i))
    EndIf       
    OutBuf(i)=AllocateMemory(iosBufSize)    
    If InBuf(i)
      FreeMemory(InBuf(i))
    EndIf          
      InBuf(i)=AllocateMemory(iosBufSize)
  Next    
  ;    
  ios\wFormatTag= #WAVE_FORMAT_PCM 
  ios\nChannels=Channels; -  
  ios\nSamplesPerSec=SamplesPerSec ;96000, 48000,32000, 22050, 24000, 11025, 8000   
  ios\wBitsPerSample =BitsPerSample  ; 8,16,32 bit  
  ios\nBlockAlign     = (ios\nChannels*ios\wBitsPerSample)/8 
  ios\nAvgBytesPerSec = ios\nSamplesPerSec*ios\nBlockAlign ;      
  ios\cbSize = 0  
  ProcedureReturn #iosNO_ERR 
 EndProcedure 

;      
Procedure.l iosGetNumInDevace() 
  ProcedureReturn waveInGetNumDevs_()+1;     
EndProcedure 

;      
Procedure.l iosGetNumOutDevace() 
  ProcedureReturn waveOutGetNumDevs_()+1;     
EndProcedure 

;        Num 
Procedure.s iosGetNameInDevace(Num.l) 
    If waveInGetDevCaps_(Num-2,@Caps.WAVEINCAPS,SizeOf(WAVEINCAPS))=#MMSYSERR_NOERROR 
     ProcedureReturn PeekS(@Caps\szPname,#MAXPNAMELEN) 
    EndIf 
EndProcedure 

;        Num 
Procedure.s iosGetNameOutDevace(Num.l) 
    If waveOutGetDevCaps_(Num-2,@Caps.WAVEINCAPS,SizeOf(WAVEINCAPS))=#MMSYSERR_NOERROR 
      ProcedureReturn PeekS(@Caps\szPname,#MAXPNAMELEN)    
    EndIf 
EndProcedure 

;        
Procedure.l iosGetOutVolume(Num.l) 
  Protected  Vol.l 
  waveOutGetVolume_(Num-2, @Vol) 
  ProcedureReturn Vol 
EndProcedure 

;      
Procedure.l iosSetOutVolume(Num.l,Volume.l)
  waveOutSetVolume_(Num-2, Volume)    
EndProcedure 

;  
;NumInDev   ,  0     
;NumOutDev   ,  0     
;*func      
; #iosPROCESS-  ,#iosERR-,#iosNO_INIT-  , #iosNO_ERR- 
Procedure.l iosStartProcess(NumInDev.l,NumOutDev.l,*func.l) 
  Protected i.l,pri.l  
  If iosProcessStart=1 
    ProcedureReturn #iosPROCESS 
  EndIf 
  If ios\wFormatTag<>1 And iosBifSize=0 
    ProcedureReturn #iosNO_INIT 
  EndIf 
  If NumInDev>0 And NumOutDev>0 
    If #MMSYSERR_NOERROR = waveInOpen_(@ioswi,#WAVE_MAPPER+NumInDev-2,@ios,@iosInOutProc(),0,#CALLBACK_FUNCTION|#WAVE_FORMAT_DIRECT) 
        ;  e 
      For i=0 To iosNBuf 
        iosbufIN(i)\lpData = InBuf(i)    
        iosbufIN(i)\dwBufferLength = iosBufSize 
        waveInPrepareHeader_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));.   
        waveInAddBuffer_(ioswi,iosbufIN(i),SizeOf(WAVEHDR))      
      Next 
    Else 
      ProcedureReturn #iosERR 
    EndIf 
    If #MMSYSERR_NOERROR = waveOutOpen_(@ioswo,#WAVE_MAPPER+NumOutDev-2,@ios,0,0,#CALLBACK_NULL|#WAVE_FORMAT_DIRECT) 
        ;  e 
      For i=0 To iosNBuf 
       iosbufOUT(i)\lpData = OutBuf(i)    
       iosbufOUT(i)\dwBufferLength = iosBufSize      
       waveOutPrepareHeader_(ioswo, @iosbufOUT(i), SizeOf(WAVEHDR));.        
      Next      
    Else 
      ProcedureReturn #iosERR 
    EndIf 
  EndIf 
  If NumInDev>0 And NumOutDev=0 
    If #MMSYSERR_NOERROR = waveInOpen_(@ioswi,#WAVE_MAPPER+NumInDev-2,@ios,@iosInProc(),0,#CALLBACK_FUNCTION|#WAVE_FORMAT_DIRECT) 
        ;  e 
      For i=0 To iosNBuf      
        iosbufIN(i)\lpData = InBuf(i)    
        iosbufIN(i)\dwBufferLength = iosBufSize 
        waveInPrepareHeader_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));.   
        waveInAddBuffer_(ioswi,iosbufIN(i),SizeOf(WAVEHDR))      
      Next 
    Else 
      ProcedureReturn #iosERR 
    EndIf 
  EndIf 
  If NumInDev=0 And NumOutDev>0 
    If #MMSYSERR_NOERROR = waveInOpen_(@ioswi,#WAVE_MAPPER,@ios,@iosOutProc(),0,#CALLBACK_FUNCTION|#WAVE_FORMAT_DIRECT) 
        ;  e 
      For i=0 To iosNBuf 
        iosbufIN(i)\lpData = InBuf(i)    
        iosbufIN(i)\dwBufferLength = iosBufSize 
        waveInPrepareHeader_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));.   
        waveInAddBuffer_(ioswi,iosbufIN(i),SizeOf(WAVEHDR))      
      Next 
    Else 
      ProcedureReturn #iosERR 
    EndIf 
    If #MMSYSERR_NOERROR = waveOutOpen_(@ioswo,#WAVE_MAPPER+NumOutDev-2,@ios,0,0,#CALLBACK_NULL|#WAVE_FORMAT_DIRECT) 
        ;  e 
      For i=0 To iosNBuf 
       iosbufOUT(i)\lpData = OutBuf(i)    
       iosbufOUT(i)\dwBufferLength = iosBufSize      
       waveOutPrepareHeader_(ioswo, @iosbufOUT(i), SizeOf(WAVEHDR));.        
      Next      
    Else 
      ProcedureReturn #iosERR 
    EndIf 
  EndIf        
    If #MMSYSERR_NOERROR <>  waveInStart_(iosWi);    
      ProcedureReturn #iosERR 
    EndIf 
  *iosFunc=*func        
  iosProcessStart=1 
  ProcedureReturn #iosNO_ERR 
EndProcedure 

;  
; #iosNO_ERR-, #iosABSENT-   
Procedure.l iosStopProcess() 
  Protected i.l 
  If iosProcessStart.l=1 
  iosProcessStart=0 
  While iosProcessStart=0 
    Delay(1) 
  Wend 
    waveInStop_(ioswi);    
    waveInReset_(ioswi); 
    waveOutReset_(ioswo)              
    For i=0 To iosNBuf 
      waveInUnprepareHeader_(ioswi, @iosbufIN(i), SizeOf(WAVEHDR));        
      waveOutUnprepareHeader_(ioswo, @iosbufOUT(i), SizeOf(WAVEHDR));      
    Next    
    waveInClose_(ioswo); 
    waveOutClose_(ioswo);                       
    iosProcessStart.l=0 
    ProcedureReturn #iosNO_ERR 
  Else 
    ProcedureReturn #iosABSENT  
  EndIf 
EndProcedure 


; IDE Options = PureBasic 4.60 (Windows - x86)
; CursorPosition = 78
; FirstLine = 6
; Folding = ---
; Executable = IOSound1.exe.dll.exe