$regfile = "m8def.dat"                                      '  .
$crystal = 12000000                                         '  , .
$hwstack = 50                                               '  .
$swstack = 50                                               '   .
$framesize = 50

'$noframeprotect
'$romstart = 128

Config Portb = Output
Config Portc = Output
Config Portd = &B11110000

$include "USB\USB_Config.bas"                               '     
$include "USB\Const_swusb-includes.bas"                     '  USB .


Config Timer1 = Timer , Prescale = 8
On Timer1 Timer1_interrupts Nosave                          '     Timer1.
Enable Timer1

Declare Sub Endpoint_1()
Declare Sub Soft_pwm()
Declare Sub Timer_proc()

Dim Pwm_channel_ar(16) As Byte                              '   (0-255).
Dim Usb_buff_ar(16) As Byte
Dim Pwm_count As Byte
Dim I As Byte
Dim X As Byte
Dim Count_timer As Byte
Dim Packet_counter As Byte
Dim Break_packet_flag As Byte
Dim No_packet_flag As Byte
Dim Pwm_minus_flag As Byte
Dim Pwm_minus_old As Byte


Enable Interrupts
                                          '  .
   'Pwm_channel_ar(6) = 250

   No_packet_flag = 1
   Pwm_minus_flag = 1

'   Do -  Loop.
Do

  Call Usb_refresh()

 '    .
 If _usb_status._usb_rxc = 1 Then
   If _usb_status._usb_setup = 1 Then
     '      .
     Call Usb_processsetup(_usb_tx_status)
   Elseif _usb_status._usb_endp1 = 0 Then
     '       1  .

       Call Endpoint_1()

   End If
   '      .
   _usb_status._usb_rtr = 1
   _usb_status._usb_rxc = 0
 End If

 Call Soft_pwm()
 Call Timer_proc()


Loop                                                        '   .
End

$include "USB\USB_Descriptor.bas"                           '       .
$include "USB\USB_Subroutines.bas"                          '      .


Sub Endpoint_1()

     Count_timer = 0
     No_packet_flag = 0
     Pwm_minus_flag = 0

     If Break_packet_flag <> 0 Then                         '    .
       Break_packet_flag = 0
       Packet_counter = 1
       Gosub Clearbuff
     Else                                                   '    .
       Packet_counter = Packet_counter + 1
     End If

       If Packet_counter = 1 Then
         For I = 1 To 8
           Usb_buff_ar(i) = _usb_rx_buffer(i + 1)
         Next I
       Elseif Packet_counter = 2 Then
         For I = 9 To 16
           Usb_buff_ar(i) = _usb_rx_buffer(i - 7)
         Next I
       End If

     If Packet_counter >= 2 Then
        Packet_counter = 0
        For I = 1 To 16
          Pwm_channel_ar(i) = Usb_buff_ar(i)
        Next I
        Gosub Clearbuff
     End If

End Sub



Sub Soft_pwm()


  X = 1

  For I = 4 To 7

    If Pwm_channel_ar(x) > Pwm_count Then
       Portd.i = 1
    Else
       Portd.i = 0
    End If

    Incr X
  Next I

  For I = 0 To 5

    If Pwm_channel_ar(x) > Pwm_count Then
       Portb.i = 1
    Else
       Portb.i = 0
    End If

    Incr X
  Next I


  For I = 0 To 5

    If Pwm_channel_ar(x) > Pwm_count Then
       Portc.i = 1
    Else
       Portc.i = 0
    End If

    Incr X
  Next I

  Incr Pwm_count
  Pwm_count = Pwm_count And 63

End Sub



Sub Timer_proc()

 If Count_timer > 100 Then                                  '   4      .
   If No_packet_flag = 0 Then
     No_packet_flag = 1
     Pwm_minus_flag = 1
     Gosub Clearbuff
   End If
 End If

 If Count_timer > 2 Then
   If Break_packet_flag = 0 Then
     Break_packet_flag = 1
   End If

   If Pwm_minus_flag = 1 Then
     If Count_timer <> Pwm_minus_old Then
       Gosub Pwm_minus
       Pwm_minus_old = Count_timer
     End If
   End If

 End If


End Sub


Pwm_minus:
  X = 0
  For I = 1 To 16
    If Pwm_channel_ar(i) > 0 Then
      Pwm_channel_ar(i) = Pwm_channel_ar(i) - 1
      X = 1
    End If
  Next I

  If X = 0 Then
    Pwm_minus_flag = 0
  End If

Return


Clearbuff:
  For I = 1 To 16
    Usb_buff_ar(i) = 0
  Next I
Return




Timer1_interrupts:                                          '    .
sei                                                         '  .

push R24
!in R24,sreg
push R24

    Lds R24, {Count_timer}
    inc R24                                                 '  
    Sts {Count_timer}, R24

pop R24
!out sreg,R24
pop R24
Return